#!/bin/sh
#
# $Copyright: Copyright (c) 2023 Veritas Technologies LLC.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# VERITAS TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
#
# The  Licensed  Software  and  Documentation  are  deemed  to be commercial
# computer  software  as  defined  in  FAR  12.212 and subject to restricted
# rights  as  defined in FAR Section 52.227-19 "Commercial Computer Software
# - Restricted  Rights"  and  DFARS 227.7202,  et seq.  "Commercial Computer
# Software  and  Commercial Computer Software Documentation," as applicable,
# and any successor regulations, whether delivered by Veritas as on premises
# or  hosted  services.  Any  use,  modification,  reproduction  release,
# performance,  display  or  disclosure  of  the  Licensed  Software  and
# Documentation by the U.S. Government shall be solely in accordance with
# the terms of this Agreement. $
# $Revision$
# $Source$
#

# Possible values for $1 in %post: 1 for install, 2 for upgrade
# This script is called in case of fresh install & upgrade
install_type=$1

add_fun(){
result="`$@ 2>&1`"
if [ $? -eq 1 ]; then
        if [ `echo "$result" | grep -c "already exist"` -eq 1 -o `echo "$result" | grep -c "already in"` -eq 1 ]; then
                :
        else
                echo "$@";
        fi
fi
}

VCSHOME="${VCS_HOME:-/opt/VRTSvcs}"
ro=`${VCSHOME}/bin/haclus -value ReadOnly`
if [ $ro -eq 1 ];
then
        ${VCSHOME}/bin/haconf -makerw
fi

add_fun "${VCSHOME}/bin/hatype -add MirrorView"
${VCSHOME}/bin/hatype -modify MirrorView SourceFile "./MirrorViewTypes.cf"
${VCSHOME}/bin/hatype -modify MirrorView SupportedActions resync PreSwitch addArrayUser

if [ $install_type -eq 1 ]; then
        # case of fresh installation to update default values. Not required in case of upgrade.
	${VCSHOME}/bin/hatype -modify MirrorView MonitorInterval 300
	${VCSHOME}/bin/hatype -modify MirrorView NumThreads 1
	${VCSHOME}/bin/hatype -modify MirrorView OpenTimeout 180
fi

${VCSHOME}/bin/hatype -modify MirrorView ArgList NaviCliHome LocalArraySPNames RemoteArraySPNames Mode GrpName MirNames SplitTakeover LocalArraySecurityFilePath RemoteArraySecurityFilePath
os=`uname -s`;
if [ "X$os" = "XAIX" ]
then
    add_fun "${VCSHOME}/bin/haattr -add MirrorView NaviCliHome -string "/usr/lpp/NAVICLI/""
else
    add_fun "${VCSHOME}/bin/haattr -add MirrorView NaviCliHome -string "/opt/Navisphere/bin""
fi
add_fun "${VCSHOME}/bin/haattr -add MirrorView LocalArraySPNames -string -vector"
add_fun "${VCSHOME}/bin/haattr -add MirrorView RemoteArraySPNames -string -vector"
add_fun "${VCSHOME}/bin/haattr -add MirrorView Mode -string"
add_fun "${VCSHOME}/bin/haattr -add MirrorView GrpName -string"
add_fun "${VCSHOME}/bin/haattr -add MirrorView MirNames -string -vector"
add_fun "${VCSHOME}/bin/haattr -add MirrorView SplitTakeover -boolean 0"
add_fun "${VCSHOME}/bin/haattr -add MirrorView LocalArraySecurityFilePath -string"
add_fun "${VCSHOME}/bin/haattr -add MirrorView RemoteArraySecurityFilePath -string"
add_fun "${VCSHOME}/bin/haattr -add -temp MirrorView VCSResLock -string"

add_fun "${VCSHOME}/bin/hatype -add MirrorViewSnap"
${VCSHOME}/bin/hatype -modify MirrorViewSnap SourceFile "./MirrorViewTypes.cf"
${VCSHOME}/bin/hatype -modify MirrorViewSnap SupportedActions devscan
${VCSHOME}/bin/hatype -modify MirrorViewSnap ArgList StorageGrpName TargetResName

if [ $install_type -eq 1 ]; then
        # case of fresh installation to update default values. Not required in case of upgrade.
	${VCSHOME}/bin/hatype -modify MirrorViewSnap MonitorInterval 300
	${VCSHOME}/bin/hatype -modify MirrorViewSnap OpenTimeout 180
	${VCSHOME}/bin/hatype -modify MirrorViewSnap NumThreads 1
	${VCSHOME}/bin/hatype -modify MirrorViewSnap OnlineTimeout 600
	${VCSHOME}/bin/hatype -modify MirrorViewSnap RestartLimit 1
fi

add_fun "${VCSHOME}/bin/haattr -add MirrorViewSnap StorageGrpName -string"
add_fun "${VCSHOME}/bin/haattr -add MirrorViewSnap TargetResName -string"
add_fun "${VCSHOME}/bin/haattr -add -temp MirrorViewSnap Responsibility -string"
${VCSHOME}/bin/haattr -add -temp MirrorViewSnap VCSResLock -string 2>/dev/null

${VCSHOME}/bin/hatype -modify MirrorViewSnap SupportedActions devscan 2>/dev/null

${VCSHOME}/bin/hatype -modify  CVMVolDg SupportedActions -add import 2>/dev/null
${VCSHOME}/bin/hatype -modify  CVMVolDg SupportedActions -add deport 2>/dev/null

if [ $ro -eq 1 ];
then
        ${VCSHOME}/bin/haconf -dump -makero
else
        ${VCSHOME}/bin/haconf -dump
fi
